import os, sys, pygame, random, math, time
import data, functions, objects
from pygame.locals import *
pygame.init()
#pygame.font.init()

tinyFont = pygame.font.Font(data.filepath("kidsn.ttf"), 8)
smallFont = pygame.font.Font(data.filepath("kidsn.ttf"), 14)
normalFont = pygame.font.Font(data.filepath("kidsn.ttf"), 16) 
hugeFont = pygame.font.Font(data.filepath("kidsn.ttf"), 26)

'''
#sounds were very annoying
channel=pygame.mixer.find_channel()
up_wav=pygame.mixer.Sound(data.filepath("up.wav"))
down_wav=pygame.mixer.Sound(data.filepath("down.wav"))
left_wav=pygame.mixer.Sound(data.filepath("left.wav"))
right_wav=pygame.mixer.Sound(data.filepath("right.wav"))
'''

class Level:
    def __init__(self, num, screen):
        self.num=num
        self.screen=screen
        if self.num==0:
            self.background=data.load_image('title.png')
        elif self.num==7:
            self.background=data.load_image('end.png')
        else:
            self.background=data.load_image('borders.png')
        self.passed=False
        self.cheat=False
        self.selected=0
        if self.num<3:
            self.line0=hugeFont.render('Tutorial '+str(self.num), 0, (0,0,0))
        elif self.num<7: 
            self.line0=hugeFont.render('Level '+str(self.num-2), 0, (0,0,0))
        else:
            self.line0=hugeFont.render('Davide Rules - by ilseppia', 0, (0,0,0))
        self.line1=hugeFont.render('', 0, (0,0,0))
        self.line2=hugeFont.render('', 0, (0,0,0)) 
        self.line3=hugeFont.render('', 0, (0,0,0)) 
        self.line4=normalFont.render('', 0, (0,0,0))  
        self.line5=normalFont.render('', 0, (0,0,0))  
        self.line6=normalFont.render('', 0, (0,0,0)) 
        self.allChildrens=[]
        self.blindChildrens=[]
        self.me=None
        self.target=None
        self.target_img=None
        self.caugth_img=data.load_image('caugth.png')

        if self.num>0:
            self.generate_player()
        self.generate_com()            
        if self.num>0:
            self.choose_target()      

    def generate_com(self):
        children=[]
        children.append('Anastasia')
        children.append('Carmelo')
        children.append('Giuseppe')
        children.append('Mario')
        children.append('Olivia')
        children.append('Vitty')   
        random.shuffle(children)
        
        if self.num==0:#menu
            num_of_com=6
        elif self.num==1:#tutorial 1
            num_of_com=1
        elif self.num==2:#tutorial 2
            num_of_com=2            
        elif self.num<6:#level 1,2,3
            num_of_com=self.num-1
        elif self.num>=6:#level 4
            num_of_com=len(children)
        for i in range(1,num_of_com+1):
            collides=True           
            while collides==True:
                collides=False                
                newpos=pygame.Rect(random.randrange(self.screen.get_width()),random.randrange(self.screen.get_height()),30,30)
                for ac in self.allChildrens:
                    if newpos.colliderect(ac.pos):
                        #print 'collides with '+str(ac.pos)
                        collides=True
                        break
            newChild=objects.Child(i, children[i-1], self, newpos[:2])
            self.allChildrens.append(newChild)
            self.blindChildrens.append(newChild)        
        
    def generate_player(self):
        self.me=objects.Davide(0, 'davide', self, [self.screen.get_width()/2,self.screen.get_height()/2])
        self.allChildrens.append(self.me)
    
    def choose_target(self):
        if self.num>2 and self.num<7:
            self.target=random.choice(self.blindChildrens)
            self.target_img=self.target.image
            self.target.isTarget=True
            
                
    
    def update(self):
        self.screen.fill((255, 255, 255))
        self.screen.blit(self.background,[0,0])    
        #level borders
        #pygame.draw.rect(self.screen,[0,0,0],pygame.Rect(60,60,self.screen.get_width()-120,self.screen.get_height()-120),5)
        #volume bars
        if self.me!=None:        
            volume_text=smallFont.render('Vol.', 0, (0,0,0))
            self.screen.blit(volume_text, [10,200])
            for i in range(6,self.me.volume+1):
                pygame.draw.rect(self.screen,[17*i,0,0],pygame.Rect(10,180-10*(i-6),30,9),0)
        #target child
        if self.target!=None:
            pygame.draw.rect(self.screen,[0,0,0],pygame.Rect(5,245,45,60),5)
            self.screen.blit(self.target_img,[5,250])
            pygame.draw.rect(self.screen,[0,0,0],[10,270-self.target.pos.width/8,self.target.pos.width,self.target.pos.height/5],2)
            target_name=tinyFont.render(str(self.target.name), 0, (0,0,0))
            self.screen.blit(target_name, [10,290])             
            target_text=smallFont.render('Target', 0, (0,0,0))
            self.screen.blit(target_text, [5,310])
           
        
        
        if self.is_complete():
            self.passed=True
            return 1


        for ac in self.allChildrens:
            ac.update()
        if self.num==0:
            if self.selected==0:
                self.line1=hugeFont.render('TUTORIAL (recommended)', 0, (255,0,0))
                self.line2=hugeFont.render('PLAY', 0, (0,0,0)) 
                self.line3=hugeFont.render('QUIT', 0, (0,0,0))              
            elif self.selected==1:
                self.line1=hugeFont.render('TUTORIAL (recommended)', 0, (0,0,0))            
                self.line2=hugeFont.render('PLAY', 0, (255,0,0))
                self.line3=hugeFont.render('QUIT', 0, (0,0,0))
            elif self.selected==2:
                self.line1=hugeFont.render('TUTORIAL (recommended)', 0, (0,0,0))
                self.line2=hugeFont.render('PLAY', 0, (0,0,0))             
                self.line3=hugeFont.render('QUIT', 0, (255,0,0))
            self.screen.blit(self.line1, [self.screen.get_width()*5/12,self.screen.get_height()*3/4-self.line1.get_height()])
            self.screen.blit(self.line2, [self.screen.get_width()*5/12,self.screen.get_height()*3/4])
            self.screen.blit(self.line3, [self.screen.get_width()*5/12,self.screen.get_height()*3/4+self.line3.get_height()])
        else:
            if self.num==1:
                if self.selected==0:
                    self.line4=smallFont.render('You are Davide, the smiling guy without the eye patch.', 0, (0,0,0))
                    self.line5=smallFont.render('Since other guys are eye patched, they just move around randomly.', 0, (0,0,0))   
                    self.line6=smallFont.render('Move close to that guy using WASD or arrow keys.', 0, (0,0,0))                
                elif self.selected==1:
                    self.line4=smallFont.render('He cought you! This\'s what patched guys do: grab whatever they touch.', 0, (0,0,0))
                    self.line5=smallFont.render('Now you can\'t move until he releases you.', 0, (0,0,0))
                    self.line6=smallFont.render('Keep pressing direction opposite from him to free yourself.', 0, (0,0,0))                   
                elif self.selected==2:
                    self.line4=smallFont.render('GREEN LINE is just your voice direction. Try to change the voice volume', 0, (0,0,0))
                    self.line5=smallFont.render('to max, by rotating the mouse wheel (or by pressing R-F keys).', 0, (0,0,0))   
                    self.line6=smallFont.render('The voice volume is showed on the left side of the screen.', 0, (0,0,0))                                   
                elif self.selected==3:
                    self.line4=smallFont.render('RED LINE indicates the direction you will pronunce. E.g. if red line points up,', 0, (0,0,0))
                    self.line5=smallFont.render('you\'ll say "UP".   RED LINE follows the mouse position.', 0, (0,0,0))   
                    self.line6=smallFont.render('Try to say UP, DOWN and UP to the eye patched guy by pressing mouse left button.', 0, (0,0,0))
                elif self.selected==4:
                    self.line6=smallFont.render('Good! You still have to say DOWN and UP by pressing mouse left button.', 0, (0,0,0))
                elif self.selected==5:
                    self.line6=smallFont.render('Good! You still haveto say UP.', 0, (0,0,0))
            elif self.num==2:
                    self.line4=smallFont.render('Any catched guy is orange enhanced. Try to make one guy catch the other one.', 0, (0,0,0))
                    self.line5=smallFont.render('Last command you can say is "HOLD" by clicking mouse right button.', 0, (0,0,0))
                    self.line6=smallFont.render('Once they are enhanced, try the HOLD command on them (red enhancement).', 0, (0,0,0))                                                   
            elif self.num<7:
                self.line4=smallFont.render('Make at least '+str(self.num-2)+' guy(s) hold '+str(self.target.name), 0, (0,0,0))                
            self.screen.blit(self.line0, [80,30])
            self.screen.blit(self.line4, [65,self.screen.get_height()-50])      
            self.screen.blit(self.line5, [65,self.screen.get_height()-35])  
            self.screen.blit(self.line6, [65,self.screen.get_height()-20])             
    
    def is_complete(self):
        if self.num==1:
            if self.selected==0 and self.me.grabbed>0:
                self.selected=1
            elif self.selected==1 and self.me.grabbed==0:
                self.selected=2
            elif self.selected==2 and self.me.volume==15:
                self.selected=3     
            elif self.selected==3 and abs((math.degrees(self.blindChildrens[0].direction)-90)%360)<=45:
                self.selected=4
            elif self.selected==4 and abs((math.degrees(self.blindChildrens[0].direction)+90)%360)<=45:
                self.selected=5
            elif self.selected==5 and abs((math.degrees(self.blindChildrens[0].direction)-90)%360)<=45:
                return True
        if self.num==2:
            for bc in self.blindChildrens:
                if bc.grab!=None and bc.actionDecr==0:
                    return True
        elif self.num>2:
            totgrabbing=0
            for bc in self.blindChildrens:
                if bc.grab==self.target and bc.actionDecr==0:
                    totgrabbing+=1
            if totgrabbing>=min(self.num-2,4):
                self.screen.blit(self.caugth_img,[0,0])
                pygame.display.flip()
                time.sleep(1)
                return True
                




    def keys(self,event):
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == KEYDOWN:
            if event.key == K_BACKSPACE:
                self.passed=True
                return 0

        if self.num==0:
            if (event.type == KEYDOWN):
                if event.key == K_ESCAPE:
                    sys.exit()                
                if event.key in (K_UP,K_w):
                    self.selected=max(0,self.selected-1)
                elif event.key in (K_DOWN,K_s):
                    self.selected=min(2,self.selected+1)
                elif event.key == K_RETURN:
                    if self.selected==0:
                        self.passed=True
                        return 1
                    elif self.selected==1:
                        self.passed=True
                        return 3
                    elif self.selected==2:
                        sys.exit() 
        
        elif self.num>0:
            if (event.type == KEYDOWN):
                if event.key == K_ESCAPE:
                    self.passed=True
                    return -self.num
                elif event.key == K_PAGEUP:
                    self.passed=True
                    return 1
                elif event.key == K_PAGEDOWN:
                    self.passed=True
                    return -1
                elif event.key == K_F12:
                    self.cheat=not self.cheat
                    

            if (event.type == MOUSEBUTTONDOWN):
                if event.button == 1:
                    self.me.say('GO',pygame.mouse.get_pos())
                    '''
                    #sounds were very annoying
                    if self.me.command_dir in [math.pi/2,math.pi/4,math.pi*3/4]:
                        channel.queue(up_wav)
                    if self.me.command_dir in [-math.pi/2,-math.pi/4,-math.pi*3/4]:
                        channel.queue(down_wav)
                    if self.me.command_dir in [0,math.pi/4,-math.pi/4]:
                        channel.queue(right_wav)
                    if self.me.command_dir in [math.pi,-math.pi,math.pi*3/4,-math.pi*3/4]:
                        channel.queue(left_wav)
                    '''
                #elif event.button == 2:
                #    self.me.say('FREE',pygame.mouse.get_pos())
                elif event.button == 3:
                    self.me.say('HOLD',pygame.mouse.get_pos())
                elif event.button == 4:
                    self.me.volume=min(self.me.volume+1,15)
                elif event.button == 5:
                    self.me.volume=max(self.me.volume-1,7)
            if (event.type == MOUSEBUTTONUP):
                self.me.dir_text=normalFont.render('', 0, (0,0,0))

            elif event.type == KEYUP:
                if event.key in (K_RIGHT,K_d,K_LEFT,K_a):
                    self.me.speed[0]=0
                elif event.key in (K_UP,K_w,K_DOWN,K_s):
                    self.me.speed[1]=0
                    
            k = pygame.key.get_pressed()
            if k[K_LEFT] or k[K_a]:
                self.me.speed[0]=max(-2,self.me.speed[0]-2)
                self.me.direction=functions.calc_dir(self.me.getpos(),[self.me.getpos()[0]+self.me.speed[0],self.me.getpos()[1]+self.me.speed[1]],self.me.direction)  
            if k[K_RIGHT] or k[K_d]:
                self.me.speed[0]=min(2,self.me.speed[0]+2)
                self.me.direction=functions.calc_dir(self.me.getpos(),[self.me.getpos()[0]+self.me.speed[0],self.me.getpos()[1]+self.me.speed[1]],self.me.direction)                 
            if k[K_UP] or k[K_w]:
                self.me.speed[1]=max(-2,self.me.speed[1]-2)
                self.me.direction=functions.calc_dir(self.me.getpos(),[self.me.getpos()[0]+self.me.speed[0],self.me.getpos()[1]+self.me.speed[1]],self.me.direction)                
            if k[K_DOWN] or k[K_s]:
                self.me.speed[1]=min(2,self.me.speed[1]+2)
                self.me.direction=functions.calc_dir(self.me.getpos(),[self.me.getpos()[0]+self.me.speed[0],self.me.getpos()[1]+self.me.speed[1]],self.me.direction)               
            if k[K_r]:        
                self.me.volume=min(self.me.volume+1,15)
            if k[K_f]:        
                self.me.volume=max(self.me.volume-1,7)      
                              