'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''
import sys, pygame, random, math, os
import data
import objects, functions, levels

from pygame.locals import *
pygame.init()


size = width, height = 640, 480
fps = 30
clock = pygame.time.Clock()
screen = pygame.display.set_mode(size)
level_num=0
end_img=data.load_image('end.png')

def start(level_num):
    level=levels.Level(level_num,screen)
    return level
    

def main():
    level_num=0
    pygame.mixer.music.load(data.filepath("playground.ogg"))
    pygame.mixer.music.set_volume(0.5)
    pygame.mixer.music.play(-1)


    while True:     
        level=start(level_num)

        while (level.passed==False):
            for event in pygame.event.get():
                next=level.keys(event)
                if next!=None:
                    level_num+=next
            next=level.update()
            if next!=None:
                level_num+=next

            #level.screen.blit(objects.hugeFont.render('FPS:'+str(fps), 0, (0,0,0)), [0,0])            
            clock.tick(fps) 
            pygame.display.flip()

            



    


        
    



